#include "shapes.inc"
#include "colors.inc"
#include "textures.inc"
#include "stones.inc"

#include "car.pov"

// Black sky with red and purple clouds 
// Try adding turbulence values from 0.1 - 5.0 -- CdW
#declare flag = 
   plane{z,0 
        texture{pigment {image_map{gif "flag.gif" once}
			//scale <0.6,0.5,1>} 
			//scale <0.4,0.35,1>} 
			scale <0.5,0.3,1>}
            normal{waves 2}
            scale 20}
		translate 5*y
   rotate 90*y}

height_field {
   gif "fract003.gif" 
   water_level 0.4

   pigment {
      image_map { gif "fract003.gif" }
      quick_color White
      rotate 90*x
      scale <320.0, 256, 200.0>
      translate <0.0, 0.0, -1.0>
   }

   scale <320, 256, 200>
   scale <2.0, 1 , 2.0>
   rotate 45*y
   translate <1800.0, -103.5, 0.0>
}

//Clouds 
plane { x, 1350.0
   pigment {
      bozo
      turbulence 0.5
      colour_map {
         [0.0 0.6   colour red 1.0 green 1.0 blue 1.0 filter 1.0
                    colour red 1.0 green 1.0 blue 1.0 filter 1.0]
      }
      quick_colour red 0.7 green 0.7 blue 1.0
      scale <1000.0, 30.0, 100.0>
      //scale <1000.0, 200.0, 800.0>
   }
   finish {
      ambient 0.7
      diffuse 0.0
   }

}
#declare leg =
	union{sphere{<-4,0,0>,1.5}
          cylinder{<0,0,0>,<-4,0,0>,1.5}
          sphere{<0,0,0>,1.5}
          cylinder{<0,0,0>,<0,15,0>,1.5}
          sphere{<0,3,0>,1.5}
    }

#declare legs1 =
    union {object {leg
			scale 0.5
			translate<0,0,4>}
	       
		   object {leg 
			scale 0.5
			}
}

#declare leg2 =
	union{sphere{<-4,0,0>,1.5}
          cylinder{<0,0,0>,<-4,0,0>,1.5}
          sphere{<0,0,0>,1.5}
          cylinder{<0,0,0>,<-3,8,0>,1.5}
          sphere{<-3,8,0>,1.5}
          cylinder{<-3,8,0>,<0,15,0>,1.5}
    }

// Walking; right in front, left behind
#declare legs2 =
    union {object {leg2
			scale 0.5
			translate<0,0,4>}
	       
		   object {leg2 
			scale 0.5
			translate<0,-8,0>
			rotate<0,0,30>
			translate<0,8,0>
			}
}

// Walking; left in front, right behind
#declare legs3 =
    union {object {leg2
			scale 0.5}
	       
		   object {leg2 
			scale 0.5
			translate<0,-8,0>
			rotate<0,0,30>
			translate<0,8,4>
			}
}
#declare legs4=object{legs3}

#declare arm =
	union{sphere{<-6,0,0>,1.5}
          cylinder{<0,0,0>,<-6,0,0>,1.5}
          sphere{<0,0,0>,1.5}
          cylinder{<0,0,0>,<0,6,0>,1.5}
          sphere{<0,6,0>,1.5}
    }

#declare arms1 =
    union {object {arm
			scale 0.5
			translate<0,10,8>}
	       
		   object {arm
			scale 0.5
			translate<0,10,-2>
			}
}


#declare arm2 =
	union{sphere{<-4,-2,0>,1.5}
          cylinder{<0,0,0>,<-4,-2,0>,1.5}
          sphere{<0,0,0>,1.5}
          cylinder{<0,0,0>,<0,6,0>,1.5}
          sphere{<0,6,0>,1.5}
    }

#declare arm3 =
	union{sphere{<0,0,0>,1.5}
          cylinder{<0,0,0>,<0,10,0>,1.5}
          sphere{<0,6,0>,1.5}
    }

#declare arms2 =
    union {object {arm2
			scale 0.5
			translate<0,10,8>}
	       
		   object {arm2
			scale 0.5
			translate<0,10,-2>
			}
}

// Arms up like carrying something or running to hug.
#declare arms3 =
    union {object {arm2
			rotate 45*x
			scale 0.7
			translate<2,15,8>}
	       
		   object {arm2
			rotate -45*x
			scale 0.5
			translate<2,15,-2>
			}
}

// Arms behind like pulling something
#declare arms4 =
    union {object {arm2
			rotate 140*y
			rotate -45*x
			scale 0.7
			translate<0,13,9.3>}
	       
		   object {arm2
			rotate 140*y
			rotate 45*x
			scale 0.5
			translate<0,13,-3.3>
			}
}
// Arms lifted up like pushing something
#declare arms5 =
    union {object {arm3
			rotate 70*z
			scale 0.7
			translate<-2.5,13,9.3>}
	       
		   object {arm3
			rotate 70*z
			scale 0.7
			translate<-2.5,13,-3.3>
			}
}
//Left arm straight from the body, right bent towards head
#declare arms6 =
    union {object {arm2 
			rotate -90*z
			//scale 0.7
			translate<-6.5,15,5.3>}
	       
		   object {arm3
			rotate -90*x
			scale 0.7
			translate<-1.5,13,2>
			}
}

#declare body=
sphere{<0,6,1.8>,3.2
  scale <1,2,1.5>
}
#declare body1=object{body}
#declare body2=object{body}
#declare body3=object{body}
#declare body4=object{body}

#declare eye =
union{
sphere{<0,0,0>,0.8
   pigment{White}
}
sphere{<-0.8,0,0>0.4
   pigment {Black}
}
}
#declare nose=
sphere{<0,0,0>,0.8
    pigment{Pink}
    scale <1.5,1,1>
}

#declare head1=
   union{
		sphere{<0,0,0>,3
		    pigment{PaleGreen}
		}
		object{eye translate <-2,2,-2>}
		object{eye translate <-2,2,2>}
        object{nose rotate 20*z translate <-3,0.8,0>}
}
#declare head2=object{head1}

// Down looking head
#declare head3=
	object{head1 rotate 45*z}

#declare head4=object{head3}

//Creature carrying a ball
#declare creature=
union{object{legs3 pigment{color Yellow}}
      object{body pigment{PaleGreen}}
      object{head3 translate <-3,18,3>}
      object{arms3 pigment{color Yellow}}
      sphere{<0,0,0>,1 texture{White_Marble} 
             scale 7 translate 22*y}
}

//object {creature translate -24*x}

//Creature pulling
#declare creature2=
union{object{legs2 pigment{color CadetBlue}}
      object{body pigment{CadetBlue}}
      object{head3 translate <-3,18,3>}
      object{arms4 pigment{color Yellow}}
}

//Creature pushing
#declare creature3=
union{object{legs3 pigment{color CadetBlue}}
      object{body pigment{CadetBlue}}
      //object{head3 translate <0,20,3>}
      object{head1 translate <-3,18,3>}
      object{arms5 pigment{color Yellow}}
}

//object {creature3 translate 27*x}

//Creature walking on a sphere
#declare creature4=
union{object{legs2 pigment{color Orange}}
      object{body pigment{Red}}
      object{head1 translate <-3,18,3>}
      object{arms1 pigment{color Orange}}
}

//object {creature4 translate <-45,20,0>}
//sphere {<-42,10,0>,10 texture {PinkAlabaster scale 7}}

#declare creature00=
union{object{legs1 pigment{color Orange}}
      object{body pigment{Grey}}
      object{head1 translate <-3,18,3>}
      object{arms6 pigment{color Orange}}
}

#declare composition=
union{object{creature2 translate -10*x}
      object {creature3 translate 27*x}
      object{car translate -10*z}
      translate 10*x
}


sphere {
   <0.0, -49000.0, -200.0>, 50000.0
   inverse

   texture {
      pigment {
         Bright_Blue_Sky
         scale <3000.0, 700.0, 3000.0>
         quick_color SkyBlue
      }
      finish {
         crand 0.05
         ambient 0.7
         diffuse 0.0
      }
   }
}

#declare creature0=
	union{object{legs3 pigment{color Yellow}}
	object{body3 pigment{color Aquamarine}}
	object{head3 translate<-3,18,3>}
	object{arms3 pigment{color Blue}}
	sphere{<0,-10,0>,10 texture{White_Marble scale 7}}}
	object {creature0 translate <-75,20,0>}
#declare creature1=
	union{object{legs1 pigment{color Yellow}}
	object{body4 pigment{color PaleGreen}}
	object{head3 translate<-3,18,3>}
	object{arms3 pigment{color Aquamarine}}
	sphere{<0,-10,0>,10 texture{Grnt2 scale 7}}}
	object {creature1 translate <-50,20,0>}

#declare creature2=
	union{object{legs2 pigment{color CadetBlue}}
	object{body3 pigment{color PaleGreen}}
	object{head1 translate<-5,15,3>}
	object{arms3 pigment{color Orange}}
	object{Cube texture{Stone4} rotate 45*z scale 7 translate <4,22,0>}}
	object {creature2 scale 1.3 translate -28*x}

#declare creature03=
	union{object {creature00 translate <25,35,5>}
          cylinder{<0,0,0>,<0,45,0>,0.5 texture{DMFWood4} translate<25,33,0>}
          cone{<0,0,0>,1,<-14,0,0>,1.5 
              texture{Brass_Metal} translate<20,55,10>}
		  plane{x,-14 clipped_by{ cone{<0,0,0>,1,<-14.1,0,0>,1.5}}
			texture{Glass} finish{reflection 0.7}}
          object{flag scale<1.5,1,1> translate <25,67,0>}}
object {composition translate <40,0,-50>}
object{creature03 translate <40,0,-50>}

//Here is a place to insert the code
#declare creature0=
	union{object{legs3 pigment{color Yellow}}
	object{body3 pigment{color Blue}}
	object{head3 translate<-3,18,3>}
	object{arms4 pigment{color Blue}}
	sphere{<0,-10,0>,10 texture{Pink_Granite scale 7}}}
	object {creature0 translate <0,20,0>}
#declare creature1=
	union{object{legs2 pigment{color Yellow}}
	object{body4 pigment{color PaleGreen}}
	object{head3 translate<-3,18,3>}
	object{arms2 pigment{color Aquamarine}}
	sphere{<0,-10,0>,10 texture{Grnt2 scale 7}}}
	object {creature1 translate <25,20,0>}
#declare creature2=
	union{object{legs2 pigment{color Aquamarine}}
	object{body3 pigment{color PaleGreen}}
	object{head1 translate<-3,18,3>}
	object{arms3 pigment{color Aquamarine}}
	sphere{<0,0,0>,1 texture{Stone4} scale 7 translate 22*y}}
	object {creature2 translate 50*x}
#declare creature3=
	object {composition translate 75*x}
object{creature3}
#declare creature5=
	union{object{legs4 pigment{color Red}}
	object{body3 pigment{color CadetBlue}}
	object{head2 translate<-3,18,3>}
	object{arms2 pigment{color CadetBlue}}
	sphere{<0,-10,0>,10 texture{Sapphire_Agate scale 7}}}
	object {creature5 translate <130,20,0>}
#declare creature6=
	union{object{legs1 pigment{color Orange}}
	object{body4 pigment{color Pink}}
	object{head4 translate<-3,18,3>}
	object{arms3 pigment{color White}}
	sphere{<0,-10,0>,10 texture{Jade scale 7}}}
	object {creature6 translate <155,20,0>}
#declare creature7=
	union{object{legs1 pigment{color White}}
	object{body2 pigment{color Blue}}
	object{head4 translate<-3,18,3>}
	object{arms3 pigment{color Aquamarine}}
	sphere{<0,0,0>,1 texture{Jade} scale 7 translate 22*y}}
	object {creature7 translate 180*x}
#declare creature8=
	union{object{legs3 pigment{color Blue}}
	object{body2 pigment{color White}}
	object{head4 translate<-3,18,3>}
	object{arms3 pigment{color PaleGreen}}
	sphere{<0,-10,0>,10 texture{Stone2 scale 7}}}
	object {creature8 translate <205,20,0>}
#declare creature9=
	union{object{legs4 pigment{color Blue}}
	object{body3 pigment{color White}}
	object{head2 translate<-3,18,3>}
	object{arms4 pigment{color Green}}
	sphere{<0,-10,0>,10 texture{Grnt1 scale 7}}}
	object {creature9 translate <230,20,0>}
#declare creature10=
	object {composition translate 255*x}
object{creature10}
#declare creature12=
	object {composition translate 310*x}
object{creature12}
#declare creature14=
	union{object{legs2 pigment{color Pink}}
	object{body1 pigment{color Green}}
	object{head2 translate<-3,18,3>}
	object{arms3 pigment{color Aquamarine}}
	sphere{<0,0,0>,1 texture{Grnt0} scale 7 translate 22*y}}
	object {creature14 translate 365*x}
#declare creature15=
	object {composition translate 390*x}
object{creature15}
#declare creature17=
	object {composition translate 445*x}
object{creature17}
#declare creature19=
	union{object{legs4 pigment{color Orange}}
	object{body2 pigment{color Orange}}
	object{head3 translate<-3,18,3>}
	object{arms2 pigment{color Red}}
	sphere{<0,-10,0>,10 texture{Grnt4 scale 7}}}
	object {creature19 translate <500,20,0>}
#declare creature20=
	union{object{legs1 pigment{color Yellow}}
	object{body3 pigment{color Aquamarine}}
	object{head3 translate<-3,18,3>}
	object{arms3 pigment{color Red}}
	sphere{<0,0,0>,1 texture{Stone1} scale 7 translate 22*y}}
	object {creature20 translate 525*x}
#declare creature21=
	union{object{legs2 pigment{color Blue}}
	object{body2 pigment{color Aquamarine}}
	object{head2 translate<-3,18,3>}
	object{arms3 pigment{color Aquamarine}}
	sphere{<0,0,0>,1 texture{Grnt0} scale 7 translate 22*y}}
	object {creature21 translate 550*x}
#declare creature22=
    union{object{legs2 pigment{color PaleGreen}}
    object{body3 pigment{color Blue}}
    object{head1 translate<-3,18,3>}
    object{arms3 pigment{color Blue}}
    sphere{<0,0,0>,1 texture{Stone4} scale 7 translate 22*y}}
    object {creature22 translate 575*x}
#declare creature23=
    union{object{legs1 pigment{color Red}}
    object{body1 pigment{color CadetBlue}}
    object{head2 translate<-3,18,3>}
    object{arms3 pigment{color Green}}
    sphere{<0,0,0>,1 texture{Grnt2} scale 7 translate 22*y}}
    object {creature23 translate 600*x}
#declare creature24=
    object {composition translate 625*x}
object{creature24}
#declare creature26=
    object {composition translate 680*x}
object{creature26}
#declare creature28=
    object {composition translate 735*x}
object{creature28}
#declare creature30=
    object {composition translate 790*x}
object{creature30}
#declare creature32=
    union{object{legs4 pigment{color White}}
    object{body3 pigment{color Yellow}}
    object{head2 translate<-3,18,3>}
    object{arms3 pigment{color Yellow}}
    sphere{<0,0,0>,1 texture{White_Marble} scale 7 translate 22*y}}
    object {creature32 translate 845*x}
#declare creature33=
    object {composition translate 870*x}
object{creature33}
#declare creature35=
    object {composition translate 925*x}
object{creature35}
#declare creature37=
    union{object{legs4 pigment{color Green}}
    object{body4 pigment{color Yellow}}
    object{head1 translate<-3,18,3>}
    object{arms4 pigment{color Aquamarine}}
    sphere{<0,-10,0>,10 texture{Grnt1 scale 7}}}
    object {creature37 translate <980,20,0>}
#declare creature38=
    object {composition translate 1005*x}
object{creature38}
#declare creature40=
    union{object{legs4 pigment{color Red}}
    object{body2 pigment{color Blue}}
    object{head1 translate<-3,18,3>}
    object{arms1 pigment{color Aquamarine}}
    sphere{<0,-10,0>,10 texture{Stone3 scale 7}}}
    object {creature40 translate <1060,20,0>}
#declare creature41=
    union{object{legs4 pigment{color Orange}}
    object{body4 pigment{color Aquamarine}}
    object{head2 translate<-3,18,3>}
    object{arms3 pigment{color Yellow}}
    sphere{<0,0,0>,1 texture{Stone4} scale 7 translate 22*y}}
    object {creature41 translate 1085*x}
#declare creature42=
    union{object{legs3 pigment{color Pink}}
    object{body2 pigment{color Aquamarine}}
    object{head2 translate<-3,18,3>}
    object{arms3 pigment{color Blue}}
    sphere{<0,-10,0>,10 texture{Grnt1 scale 7}}}
    object {creature42 translate <1110,20,0>}
#declare creature43=
    union{object{legs3 pigment{color PaleGreen}}
    object{body2 pigment{color White}}
    object{head1 translate<-3,18,3>}
    object{arms3 pigment{color Yellow}}
    sphere{<0,0,0>,1 texture{Sapphire_Agate} scale 7 translate 22*y}}
    object {creature43 translate 1135*x}
#declare creature44=
    union{object{legs4 pigment{color Red}}
    object{body4 pigment{color Red}}
    object{head2 translate<-3,18,3>}
    object{arms3 pigment{color PaleGreen}}
    sphere{<0,0,0>,1 texture{Grnt5} scale 7 translate 22*y}}
    object {creature44 translate 1160*x}
#declare creature45=
    object {composition translate 1185*x}
object{creature45}
#declare creature47=
    union{object{legs3 pigment{color Orange}}
    object{body3 pigment{color Pink}}
    object{head2 translate<-3,18,3>}
    object{arms3 pigment{color Orange}}
    sphere{<0,0,0>,1 texture{Stone2} scale 7 translate 22*y}}
    object {creature47 translate 1240*x}
#declare creature48=
    union{object{legs2 pigment{color Blue}}
    object{body1 pigment{color Yellow}}
    object{head4 translate<-3,18,3>}
    object{arms3 pigment{color Blue}}
    sphere{<0,0,0>,1 texture{Grnt3} scale 7 translate 22*y}}
    object {creature48 translate 1265*x}
#declare creature49=
    union{object{legs1 pigment{color Blue}}
    object{body1 pigment{color Orange}}
    object{head2 translate<-3,18,3>}
    object{arms4 pigment{color Orange}}
    sphere{<0,-10,0>,10 texture{White_Marble scale 7}}}
    object {creature49 translate <1290,20,0>}
#declare creature50=
    union{object{legs3 pigment{color Red}}
    object{body4 pigment{color CadetBlue}}
    object{head3 translate<-3,18,3>}
    object{arms3 pigment{color PaleGreen}}
    sphere{<0,0,0>,1 texture{Stone4} scale 7 translate 22*y}}
    object {creature50 translate 1315*x}
#declare creature51=
    union{object{legs3 pigment{color CadetBlue}}
    object{body1 pigment{color White}}
    object{head4 translate<-3,18,3>}
    object{arms1 pigment{color Pink}}
    sphere{<0,-10,0>,10 texture{Grnt1 scale 7}}}
    object {creature51 translate <1340,20,0>}
#declare creature52=
    union{object{legs2 pigment{color Green}}
    object{body4 pigment{color CadetBlue}}
    object{head3 translate<-3,18,3>}
    object{arms3 pigment{color CadetBlue}}
    sphere{<0,0,0>,1 texture{Stone4} scale 7 translate 22*y}}
    object {creature52 translate 1365*x}
#declare creature53=
    union{object{legs2 pigment{color Pink}}
    object{body3 pigment{color Pink}}
    object{head1 translate<-3,18,3>}
    object{arms1 pigment{color CadetBlue}}
    sphere{<0,-10,0>,10 texture{Stone4 scale 7}}}
    object {creature53 translate <1390,20,0>}
#declare creature54=
    union{object{legs2 pigment{color Blue}}
    object{body3 pigment{color Blue}}
    object{head2 translate<-3,18,3>}
    object{arms4 pigment{color PaleGreen}}
    sphere{<0,-10,0>,10 texture{Pink_Granite scale 7}}}
    object {creature54 translate <1415,20,0>}
#declare creature55=
    union{object{legs4 pigment{color Blue}}
    object{body3 pigment{color Aquamarine}}
    object{head4 translate<-3,18,3>}
    object{arms2 pigment{color Red}}
    sphere{<0,-10,0>,10 texture{Pink_Granite scale 7}}}
    object {creature55 translate <1440,20,0>}
#declare creature56=
    union{object{legs4 pigment{color White}}
    object{body1 pigment{color PaleGreen}}
    object{head1 translate<-3,18,3>}
    object{arms3 pigment{color PaleGreen}}
    sphere{<0,0,0>,1 texture{Grnt1} scale 7 translate 22*y}}
    object {creature56 translate 1465*x}


light_source {
    <800,800,-800> color White 
}

light_source {
    <-800,800,-800> color White 
}


plane{y, 0 
  texture{Cork scale 0.01}
}

camera {
    location <-78, 35, -87>
    look_at  <60, 30, 0>
}

